//////////////////////////////////////////////////////////////////////////////
//
// 	Filename:	Command.h
//	Version:		
//
//	Author:		Liu, Zemin  (jyetek@gmail.com)
//	Company:	JYE Tech
//	Web: 		www.jyetech.com
//
//-----------------------------------------------------------------------------
//
// 	Target: 		ATmega64
// 	Tool chain: 	WinAvr (GCC-AVR)
//
//
//-----------------------------------------------------------------------------
//	Required files:
//
//-----------------------------------------------------------------------------
//	Notes:
//
//
//-----------------------------------------------------------------------------
//	Revision History:
//
///////////////////////////////////////////////////////////////////////////////
//
//
#ifndef	Command_h
#define	Command_h

#include	"Common.h"

// ============== Key Analysis Definitions =====================

// -- Key Code Definitions
#define	KVoid			0x00

#define	KTimeBase		0x07
#define	KHPos			0x08

#define	KTrigMode		0x09
#define	KTrigSrc			0x0A
#define	KTrigEdge		0x0B
#define	KTrigLvl			0x0C
#define	KTrigPos		0x0D
#define	KAdjUp			0x18
#define	KAdjDown		0x19

#define	KVPos			0x1A
#define	KOK				0x1B

#define	KHold			0x1E
#define	KAux			0x1F

#define	KAdjUpH		0x98	// Hold
#define	KAdjDownH		0x99	// Hold
#define	KHoldH			0x9E

// -- Key code conversion 
typedef	struct	{
	U16 	ScanCode;
	U8	Keycode;
	}KeyMap ;

// -- Command Entry Structure
typedef	struct	{
	U8 	CmdCode;
	U8	NextState;
	CmdFuncPointer	CmdAction;
//	void	(*CmdAction)();
	}CmdEntry ;

enum	KeyStates {
	KS_Run,				// Initial state
	KS_Hold,			// Hold state
	KS_SaveWaveform,
	KS_SaveWaveformEnd,
	KS_DispWaveform,
	KS_Last
	};

enum	Type_Focus {
	FC_First,
	FC_TBRate,
	FC_HPos,
	FC_VPos,
	FC_TrigMode,
	FC_TrigEdge,
	FC_Triglvl,
	FC_Last
	};

extern	enum	Type_Focus 	Focus;
extern	enum	Type_Focus 	PrevFocus;
extern	U8	KeyCode;
extern	U8	KeyParam;
extern	enum	KeyStates  KeyState;

// ====================================================
//	Function Prototype Declarations
// ====================================================
//
U8	KeyConvert(U16 KScancode, KeyMap *keymap);
void	CmdProc(void);
void	*CmdAnalysis(U8 Ccode, CmdEntry *CmdTab, U8 *PState);
void CmdInit(void);
void	KF_SelVPos(void);
void	KF_SelHPos(void);
void	KF_SelTimeBase(void);
void	KF_SelTrigMode(void);
void	KF_SelTrigEdge(void);
void	KF_SelTrigLevel(void);
void	KF_SelTrigSrc(void);
void	KF_AdjUp(void);
void	KF_AdjDown(void);
void	KF_Hold(void);
void	KF_ExitHold(void);
void	KF_AdjUpH(void);
void	KF_AdjDownH(void);
void KF_ToSaveWaveform(void);
void KF_DoSaveWaveform(void);
void KF_ExitSaveWaveform(void);
void KF_ToDispWaveform(void);
void KF_DoDispWaveform(void);
void KF_ExitDispWaveform(void);
void	UpdateFocus(void);
void	ParamAdj(U8 Dir);
void Dummy(void);
void Dummy1(U8 Dir);

#endif

